#include <os.h>
#include <nspireio.h>
#include "misc.h"
#include "syscalls.h"
#include "list.h"
#include "task.h"
#include "pool.h"

#define MAINMENU_SIZE 2

entry* main_create_entries()
{
	entry* e = malloc(MAINMENU_SIZE*sizeof(entry));
	strcpy(e[0].text,"Manage tasks");
	strcpy(e[1].text,"Manage memory");
	return e;
}

int main(void)
{
	entry* entries = main_create_entries();
	list* menu = create_list(0,16,8,entries,MAINMENU_SIZE);
	do
	{
		memset(SCREEN_BASE_ADDRESS,0xBB,SCREEN_BYTES_SIZE);
		
		int selection = update_list(menu);
		if(selection != -1)
		{
			wait_no_key_pressed();
			switch(selection)
			{
				case 0:
					display_tasks_screen();
					break;
				case 1:
					display_pools_screen();
					break;
			}
			memset(SCREEN_BASE_ADDRESS,0xBB,SCREEN_BYTES_SIZE);
		}
		
		nio_grid_printf(0,0,0,0,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"TI-Nspire Task Manager (built %s %s)",__DATE__,__TIME__);
		int i;
		for(i = 0; i < 53; i++)
		{
			nio_grid_putc(0,0,i,1,'-',NIO_COLOR_WHITE,NIO_COLOR_BLACK);
			nio_grid_putc(0,0,i,10,'-',NIO_COLOR_WHITE,NIO_COLOR_BLACK);
		}
		draw_list(menu);
		nio_grid_puts(0,0,0,11,"Use UP/DOWN keys to navigate, ENTER to select",NIO_COLOR_WHITE,NIO_COLOR_BLACK);
		
		wait_key_pressed();
	} while(!isKeyPressed(KEY_NSPIRE_ESC));
	
	free(entries);
	free(menu);
	return 0;
}